VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form OcrFontExplorerForm 
   Caption         =   "Ocr Font Explorer"
   ClientHeight    =   4335
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   9630
   LinkTopic       =   "Form1"
   ScaleHeight     =   4335
   ScaleWidth      =   9630
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox TextFontFilename 
      Height          =   375
      Left            =   1680
      TabIndex        =   19
      Text            =   " "
      Top             =   120
      Width           =   5895
   End
   Begin VB.Frame Pattern 
      Caption         =   "Pattern"
      Height          =   1095
      Left            =   120
      TabIndex        =   1
      Top             =   3120
      Width           =   9375
      Begin VB.CommandButton CommandGotoIdx 
         Caption         =   "Go to Index"
         Height          =   495
         Left            =   5280
         TabIndex        =   17
         Top             =   360
         Width           =   1575
      End
      Begin VB.CommandButton CommandRemPat 
         Caption         =   "Remove Pattern"
         Height          =   495
         Left            =   3600
         TabIndex        =   16
         Top             =   360
         Width           =   1575
      End
      Begin VB.CommandButton CommandNextPat 
         Caption         =   "Next Pattern >>"
         Height          =   495
         Left            =   1920
         TabIndex        =   15
         Top             =   360
         Width           =   1575
      End
      Begin VB.CommandButton CommandPrePat 
         Caption         =   "<< Previous Pattern"
         Height          =   495
         Left            =   120
         TabIndex        =   14
         Top             =   360
         Width           =   1695
      End
      Begin VB.TextBox TextGotoIdx 
         Height          =   375
         Left            =   7200
         TabIndex        =   13
         Text            =   "0"
         Top             =   360
         Width           =   1815
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "OCR Information"
      Height          =   2295
      Left            =   120
      TabIndex        =   0
      Top             =   720
      Width           =   7455
      Begin VB.TextBox TextTotNumPat 
         Height          =   375
         Left            =   5520
         TabIndex        =   9
         Text            =   " "
         Top             =   1200
         Width           =   1695
      End
      Begin VB.TextBox TextCurrPat 
         Height          =   375
         Left            =   5520
         TabIndex        =   8
         Text            =   " "
         Top             =   720
         Width           =   1695
      End
      Begin VB.TextBox TextAssocChar 
         Height          =   375
         Left            =   5520
         TabIndex        =   7
         Text            =   " "
         Top             =   240
         Width           =   1695
      End
      Begin VB.CheckBox CheckOCRExtended 
         Caption         =   "OCR Extended (Class 4)"
         Height          =   375
         Left            =   240
         TabIndex        =   6
         Top             =   1800
         Width           =   2535
      End
      Begin VB.CheckBox CheckOCRSpecial 
         Caption         =   "OCR Special (Class 3)"
         Height          =   495
         Left            =   240
         TabIndex        =   5
         Top             =   1320
         Width           =   2415
      End
      Begin VB.CheckBox CheckOCRLowerCase 
         Caption         =   "OCR LowerCase (Class 2)"
         Height          =   495
         Left            =   240
         TabIndex        =   4
         Top             =   960
         Width           =   2415
      End
      Begin VB.CheckBox CheckOCRUpperCase 
         Caption         =   "OCR UpperCase (Class 1)"
         Height          =   495
         Left            =   240
         TabIndex        =   3
         Top             =   600
         Width           =   2295
      End
      Begin VB.CheckBox CheckOCRDigit 
         Caption         =   "OCR Digit (Class 0)"
         Height          =   495
         Left            =   240
         TabIndex        =   2
         Top             =   240
         Width           =   2175
      End
      Begin VB.Label Label3 
         Caption         =   "Total Numbers of Pattern"
         Height          =   375
         Left            =   3120
         TabIndex        =   12
         Top             =   1320
         Width           =   2415
      End
      Begin VB.Label Label2 
         Caption         =   "Current Pattern Index"
         Height          =   375
         Left            =   3120
         TabIndex        =   11
         Top             =   840
         Width           =   2055
      End
      Begin VB.Label Label1 
         Caption         =   "Character Code"
         Height          =   375
         Left            =   3120
         TabIndex        =   10
         Top             =   360
         Width           =   2055
      End
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   9720
      Top             =   3720
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label Label5 
      Caption         =   "Font Filename"
      Height          =   375
      Left            =   120
      TabIndex        =   18
      Top             =   120
      Width           =   1455
   End
   Begin VB.Menu File 
      Caption         =   "File"
      Begin VB.Menu LoadFont 
         Caption         =   "Load Font File"
      End
      Begin VB.Menu SaveFont 
         Caption         =   "Save Font File"
      End
      Begin VB.Menu Exit 
         Caption         =   "Exit"
      End
   End
End
Attribute VB_Name = "OcrFontExplorerForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' +-------------------------------- DISCLAIMER ---------------------------------+
' |                                                                             |
' | This application program is provided to you free of charge as an example.   |
' | Despite the considerable efforts of Euresys personnel to create a usable    |
' | example, you should not assume that this program is error-free or suitable  |
' | for any purpose whatsoever.                                                 |
' |                                                                             |
' | EURESYS does not give any representation, warranty or undertaking that this |
' | program is free of any defect or error or suitable for any purpose. EURESYS |
' | shall not be liable, in contract, in torts or otherwise, for any damages,   |
' | loss, costs, expenses or other claims for compensation, including those     |
' | asserted by third parties, arising out of or in connection with the use of  |
' | this program.                                                               |
' |                                                                             |
' +-----------------------------------------------------------------------------+


Option Explicit


Option Base 0

' Source image for patterns
Private m_SrcImg As New EImageBW8

' The OCR Object
Public m_Ocr As New EOCR

Dim m_nPatternClass As Long
Dim m_nAssocChar As Long
Dim m_nPatIndex As Long
Dim m_nNumPat As Long

    
Private Sub CommandGotoIdx_Click()

    ' If no pattern in font, exit
    If m_nNumPat = 0 Then Exit Sub
    
    m_nPatIndex = CInt(TextGotoIdx.Text)
    
    If m_nPatIndex < 0 Then
        m_nPatIndex = 0
    End If
    
    If m_nPatIndex > m_nNumPat - 1 Then
        m_nPatIndex = m_nNumPat - 1
    End If
    
    ' Retrieve the current pattern info
    GetPatternInfo (SetCurrentPatternIndex(m_nPatIndex, m_nAssocChar))
        
    Refresh


End Sub

Private Sub CommandNextPat_Click()

    ' If no pattern in font, exit
    If m_nNumPat = 0 Then Exit Sub
    
    m_nPatIndex = m_nPatIndex + 1
    
    If m_nPatIndex > m_nNumPat - 1 Then
        m_nPatIndex = m_nNumPat - 1
    End If
    
    ' Retrieve the current pattern info
    GetPatternInfo (SetCurrentPatternIndex(m_nPatIndex, m_nAssocChar))
        
    Refresh

End Sub

Private Sub CommandPrePat_Click()

    ' If no pattern in font, exit
    If m_nNumPat = 0 Then Exit Sub
    
    m_nPatIndex = m_nPatIndex - 1
    
   
        If m_nPatIndex < 0 Then
        m_nPatIndex = 0
    End If
    

    ' Retrieve the current pattern info
    GetPatternInfo (SetCurrentPatternIndex(m_nPatIndex, m_nAssocChar))
        
    Refresh
    
End Sub

Private Sub CommandRemPat_Click()

    'If no pattern in the font, exit
    If m_nNumPat = 0 Then Exit Sub
    
    ' Remove the current pattern from the font
    m_Ocr.RemovePattern (CInt(TextGotoIdx.Text))
    
    ' Retrieve the number of patterns in the font
    m_nNumPat = m_Ocr.NumPatterns
    TextTotNumPat.Text = CStr(m_nNumPat)
    
    ' The last pattern was deleted, so exit
    If m_nNumPat = 0 Then
        m_nPatIndex = 0
        Exit Sub
    End If
    
    ' Retrieve the current pattern info
    GetPatternInfo (SetCurrentPatternIndex(m_nPatIndex, m_nAssocChar))
    
    Refresh

End Sub

Private Sub Exit_Click()

    End

End Sub

Private Sub Form_Paint()

    On Error GoTo Failure
    
    
    ' Exit if no image has been loaded
    If m_SrcImg.IsVoid Then Exit Sub

    ' Draw the current pattern
    m_SrcImg.Draw OcrFontExplorerForm.hDC, 60# / m_SrcImg.Width, 90# / m_SrcImg.Height, 550, 50
    
   On Error GoTo 0
    Exit Sub

Failure:
    ' Display the error description
    MsgBox "Error: " & Err.Description, vbOKOnly, "OCR Font Explorer"
End Sub


Private Sub LoadFont_Click()


    CommonDialog1.DialogTitle = "Select the File..."
    CommonDialog1.Flags = cdlOFNFileMustExist
    CommonDialog1.Filter = "OCR Font Files (*.ocr)*.ocr"
    
    CommonDialog1.ShowOpen
    
    If Len(CommonDialog1.FileName) <> 0 Then
        

        TextFontFilename.Text = CommonDialog1.FileName

        ' Load the font file
        m_Ocr.Load (CommonDialog1.FileName)
        
        ' Retrieve the number of patterns in font
        m_nNumPat = m_Ocr.NumPatterns
        
        TextTotNumPat.Text = CStr(m_nNumPat)
        m_nPatIndex = 0
        
        ' Retrieve the current pattern info
        GetPatternInfo (SetCurrentPatternIndex(m_nPatIndex, m_nAssocChar))
        
        Refresh
        
    End If


End Sub

Private Sub SaveFont_Click()

    CommonDialog1.DialogTitle = "Select the File..."
    CommonDialog1.Flags = cdlOFNFileMustExist
    CommonDialog1.Filter = "OCR Font Files (*.ocr)*.ocr"
    
    CommonDialog1.ShowSave
        
    If Len(CommonDialog1.FileName) <> 0 Then
    
        ' Save the modified font file
        m_Ocr.Save (CommonDialog1.FileName)
        
        Refresh
        
    End If
    
End Sub


Public Function SetCurrentPatternIndex(index As Long, ByRef ch As Long) As Long

    Dim m_un32PatternWidth As Integer
    Dim m_un32PatternHeight As Integer

    ' Retrieve the font pattern size
    m_un32PatternWidth = m_Ocr.PatternWidth
    m_un32PatternHeight = m_Ocr.PatternHeight

    Dim m_pPatternBitmap As EImageBW8
    
    ' Retrieve the current pattern bitmap pointer
    Set m_SrcImg = m_Ocr.GetPatternBitmap(index)
        
    ' Retrieve the current pattern code
    ch = m_Ocr.GetPatternCode(index)

    ' Retrieve the current pattern class
    SetCurrentPatternIndex = m_Ocr.GetPatternClass(index)

End Function

Private Sub GetPatternInfo(classes As Long)

    ' Update the current index
    TextCurrPat.Text = CStr(m_nPatIndex)
    
    ' Update the character code
    TextAssocChar.Text = ChrW(m_nAssocChar)
     
    ' Update the pattern class
    CheckOCRDigit.Value = vbUnchecked
    CheckOCRUpperCase.Value = vbUnchecked
    CheckOCRLowerCase.Value = vbUnchecked
    CheckOCRSpecial.Value = vbUnchecked
    CheckOCRExtended.Value = vbUnchecked
    
    If classes And EOCRClass_Digit Then CheckOCRDigit.Value = vbChecked
    If classes And EOCRClass_UpperCase Then CheckOCRUpperCase.Value = vbChecked
    If classes And EOCRClass_LowerCase Then CheckOCRLowerCase.Value = vbChecked
    If classes And EOCRClass_Special Then CheckOCRSpecial.Value = vbChecked
    If classes And EOCRClass_Extended Then CheckOCRExtended.Value = vbChecked
 

    Refresh

End Sub

