// harClassAndCode.cpp : implementation file
//

#include "stdafx.h"
#include "LotMixingLearn.h"
#include "CharClassAndCode.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CharClassAndCode dialog


CharClassAndCode::CharClassAndCode(CWnd* pParent /*=NULL*/)
	: CDialog(CharClassAndCode::IDD, pParent)
{
	//{{AFX_DATA_INIT(CharClassAndCode)
	m_sChar = _T("");
	m_bDigit = FALSE;
	m_bUpperCase = FALSE;
	m_bLowerCase = FALSE;
	//}}AFX_DATA_INIT
}


void CharClassAndCode::ResetParameters( )
{

	/// Reset all parameters to default
	m_sChar = "";
	m_bDigit= FALSE;
	m_bUpperCase = FALSE;
	m_bLowerCase = FALSE;
	UpdateData(FALSE);
}


void CharClassAndCode::GetParameters(CString& charCode, UINT32& classes )
{

	/// Return Character code to the calling function
	charCode = m_sChar;

	/// Return the class to the calling function
	classes= (m_bDigit? EOCRClass_Digit : 0) | (m_bUpperCase? EOCRClass_UpperCase : 0) | (m_bLowerCase? EOCRClass_LowerCase : 0);
}


void CharClassAndCode::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CharClassAndCode)
	DDX_Text(pDX, IDC_EDIT_CHAR, m_sChar);
	DDX_Check(pDX, IDC_CHECK_DIGIT, m_bDigit);
	DDX_Check(pDX, IDC_CHECK_LOWERCASE, m_bLowerCase);
	DDX_Check(pDX, IDC_CHECK_UPPERCASE, m_bUpperCase);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CharClassAndCode, CDialog)
	//{{AFX_MSG_MAP(CharClassAndCode)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CharClassAndCode message handlers

void CharClassAndCode::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	/// Reset Parameters prior to showing dialog
	ResetParameters();
	
}
