
// +-------------------------------- DISCLAIMER ---------------------------------+
// |                                                                             |
// | This application program is provided to you free of charge as an example.   |
// | Despite the considerable efforts of Euresys personnel to create a usable    |
// | example, you should not assume that this program is error-free or suitable  |
// | for any purpose whatsoever.                                                 |
// |                                                                             |
// | EURESYS does not give any representation, warranty or undertaking that this |
// | program is free of any defect or error or suitable for any purpose. EURESYS |
// | shall not be liable, in contract, in torts or otherwise, for any damages,   |
// | loss, costs, expenses or other claims for compensation, including those     |
// | asserted by third parties, arising out of or in connection with the use of  |
// | this program.                                                               |
// |                                                                             |
// +-----------------------------------------------------------------------------+
//
// CharClassAndCode.h : header file
//

#if !defined(AFX_HARCLASSANDCODE_H__566AF266_6082_44DA_8775_781FFB95F0C9__INCLUDED_)
#define AFX_HARCLASSANDCODE_H__566AF266_6082_44DA_8775_781FFB95F0C9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "Open_eVision_1_2.h"

/// Open eVision Namespace
using namespace Euresys::Open_eVision_1_2;



/////////////////////////////////////////////////////////////////////////////
// CharClassAndCode dialog

class CharClassAndCode : public CDialog
{
// Construction
public:
	CharClassAndCode(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CharClassAndCode)
	enum { IDD = IDD_DIALOG_CHARCODE };
	CString	m_sChar;
	BOOL	m_bDigit;
	BOOL	m_bUpperCase;
	BOOL	m_bLowerCase;
	//}}AFX_DATA
	void GetParameters(CString& charCode, UINT32& classes );
	void ResetParameters();
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CharClassAndCode)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CharClassAndCode)
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HARCLASSANDCODE_H__566AF266_6082_44DA_8775_781FFB95F0C9__INCLUDED_)
