// +-------------------------------- DISCLAIMER ---------------------------------+
// |                                                                             |
// | This application program is provided to you free of charge as an example.   |
// | Despite the considerable efforts of Euresys personnel to create a usable    |
// | example, you should not assume that this program is error-free or suitable  |
// | for any purpose whatsoever.                                                 |
// |                                                                             |
// | EURESYS does not give any representation, warranty or undertaking that this |
// | program is free of any defect or error or suitable for any purpose. EURESYS |
// | shall not be liable, in contract, in torts or otherwise, for any damages,   |
// | loss, costs, expenses or other claims for compensation, including those     |
// | asserted by third parties, arising out of or in connection with the use of  |
// | this program.                                                               |
// |                                                                             |
// +-----------------------------------------------------------------------------+
//
// LotMixingLearnDlg.h : header file
//

#if !defined(AFX_LOTMIXINGLEARNDLG_H__BCAE74F7_4BF3_402F_9157_3E21D8F35BCF__INCLUDED_)
#define AFX_LOTMIXINGLEARNDLG_H__BCAE74F7_4BF3_402F_9157_3E21D8F35BCF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "ImageProcessing.h"

/////////////////////////////////////////////////////////////////////////////
// CLotMixingLearnDlg dialog

class CLotMixingLearnDlg : public CDialog
{

private:
	
	ImageProcessing m_Processing;
	
// Construction
public:
	CLotMixingLearnDlg(CWnd* pParent = NULL);	// standard constructor
	CMenu m_Menu;

	void OnFileSave();
	void OnFileExit();


// Dialog Data
	//{{AFX_DATA(CLotMixingLearnDlg)
	enum { IDD = IDD_LOTMIXINGLEARN_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLotMixingLearnDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CLotMixingLearnDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();

	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);


	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()



};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LOTMIXINGLEARNDLG_H__BCAE74F7_4BF3_402F_9157_3E21D8F35BCF__INCLUDED_)
